inventory/routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

Route::get('/print', 'ReportController@generate')->name('report');

Route::get('/profil', 'ProfilController@index')->name('profil');

Route::get('/transaksi', 'TransaksiController@index')->name('transaksi');

Route::get('/trs_detail', 'TransaksiDetailController@index')->name('trs_detail');





































# Harun 

Route::resource('barang', 'BarangController')->middleware('auth');

Route::resource('kategori', 'KategoriController')->middleware('auth');

Route::get('/print/barang', 'ReportController@generateBarangReport')->name('barang.pdf')->middleware('auth');


Route::get('/erd', function () {
    return view('about/erd');
})->middleware('auth');

Route::get('/group', function () {
    return view('about/group');
})->middleware('auth');

inventory/app/Kategori.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Kategori extends Model
{
    protected $table = 'kategori';

    protected $fillable = ['nama'];
    
    public function get_barang()
    {
    	return $this->belongsToMany('App\Barang','kategori_barang','kategori_id','barang_id');
    }
    
}

inventory/app/Http/Controllers/KategoriController.php
<?php

namespace App\Http\Controllers;

use App\Kategori;
use Illuminate\Http\Request;
use Alert;

class KategoriController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $daftar_kategori = Kategori::all();

        return view('kategori.list', ['daftar_kategori' => $daftar_kategori]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('kategori.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $validatedData = $request->validate([
            'nama' => 'required|unique:kategori|max:100',            
        ]);

        $kategori = Kategori::create([
            'nama' => $request['nama']            
        ]);

        $message = 'Kategori "'. $kategori->nama .'" berhasil disimpan!';
        Alert::success('Success Title', $message)->position('bottom-end');

        return redirect()->route('kategori.index')->with('success',$message); 
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Kategori  $kategori
     * @return \Illuminate\Http\Response
     */
    public function show(Kategori $kategori)
    {
        $kategori = Kategori::find($kategori->id);

        return view('kategori.show', ['kategori' => $kategori]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Kategori  $kategori
     * @return \Illuminate\Http\Response
     */
    public function edit(Kategori $kategori)
    {
        $kategori = Kategori::find($kategori->id);

        return view('kategori.edit', ['kategori' => $kategori]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Kategori  $kategori
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Kategori $kategori)
    {
        $validatedData = $request->validate([
            'nama' => 'required|unique:kategori|max:100',            
        ]);

        $kategori = Kategori::find($kategori->id);

        $kategori->nama = $request['nama'];
        $kategori->save();
        
        $message = 'Kategori "'. $kategori->nama .'" berhasil diubah!';
        Alert::success('Success Title', $message)->position('bottom-end');

        return redirect()->route('kategori.index')->with('success',$message); 
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Kategori  $kategori
     * @return \Illuminate\Http\Response
     */
    public function destroy(Kategori $kategori)
    {
        Kategori::destroy($kategori->id);

        $message = 'Kategori "'. $kategori->nama .'" berhasil dihapus!';
        Alert::success('Success Title', $message)->position('bottom-end');

        return redirect()->route('kategori.index')->with('success',$message); 
    }
}

inventory/resources/views/kategori/create.blade.php
@extends('adminlte/master')

@section('content')

	<div class="card card-primary ml-3 mt-3 mr-3">
      <div class="card-header">
        <h3 class="card-title">Masukkan Kategori</h3>
      </div>
      <!-- /.card-header -->

		@if ($errors->any())
		    <div class="alert alert-danger">
		        <ul>
		            @foreach ($errors->all() as $error)
		                <li>{{ $error }}</li>
		            @endforeach
		        </ul>
		    </div>
		@endif

      <!-- form start -->
      <form role="form" action="{{route('kategori.store')}}" method="POST">
      	@method('POST')
      	@csrf
        
        <div class="card-body">
          <div class="form-group">
            <label for="nama_id" >Kategori</label>
            <input type="text" class="form-control" id="kategori_id" placeholder="Masukkan nama kategori" name="nama" value="{{old('nama','')}}" >
             @error('nama')
    			     <div class="alert alert-danger">{{ $message }}</div>
			       @enderror	
          </div>        
          
          
        </div>
        <!-- /.card-body -->

        <div class="card-footer">
          <button type="submit" class="btn btn-primary">Simpan Ketegori Baru</button>
        </div>
      </form>
    </div>

@endsection

inventory/resources/views/kategori/edit.blade.php
@extends('adminlte/master')

@section('content')

	<div class="card card-primary ml-3 mt-3 mr-3">
      <div class="card-header">
        <h3 class="card-title">Ubah Kategori</h3>
      </div>
      <!-- /.card-header -->

		@if ($errors->any())
		    <div class="alert alert-danger">
		        <ul>
		            @foreach ($errors->all() as $error)
		                <li>{{ $error }}</li>
		            @endforeach
		        </ul>
		    </div>
		@endif

      <!-- form start -->
      <form role="form" action="{{route('kategori.update',['kategori'=>$kategori])}}" method="POST">
      	@method('PUT')
      	@csrf
        <div class="card-body">
          <div class="form-group">
            <label for="nama_id">nama</label>
            <input type="text" class="form-control" id="nama_id" placeholder="Masukkan nama" name="nama" value="{{old('nama',$kategori->nama)}}">
            @error('isi')
  			       <div class="alert alert-danger">{{ $message }}</div>
		        @enderror
          </div>   
          
        </div>
        <!-- /.card-body -->

        <div class="card-footer">
          <button type="submit" class="btn btn-primary">Ubah Kategori</button>
        </div>
      </form>
    </div>

@endsection

inventory/resources/views/kategori/list.blade.php
@extends('adminlte/master')

@push('styles')

  <link rel="stylesheet" href="{{asset('/adminlte/plugins/datatables-bs4/css/dataTables.bootstrap4.css')}}">

@endpush

@section('content')

<div class="card">
      <div class="card-header">
        <h3 class="card-title">Daftar Kategori</h3>
      </div>
      <!-- /.card-header -->      

      <div class="card-body">

      	@if (session('success'))
		      <div class="alert alert-success" role="alert"> {{session('success')}} </div>
		    @endif

      	<a type="button" class="btn btn-primary mb-2" href="{{route('kategori.create')}}">Tambah Kategori baru</a>
      	
        <table id="example1" class="table table-bordered table-striped">
          <thead>
          <tr>
            <th>No.</th>
            <th>Nama</th>
            <th>Qty Barang dalam kategori ini</th>
            <th>Action</th>            
          </tr>
          </thead>
          <tbody>          	
          	@foreach ($daftar_kategori as $key => $kategori)    			
    			<tr>
	          		<td>{{$key+1}}</td>	
	            	<td>{{$kategori->nama}}</td>
	            	<td>{{count($kategori->get_barang)}}</td>
	            	<td style="display: flex;">
	            		<a type="button" class="btn btn-info btn-sm" href="{{route('kategori.show',['kategori'=>$kategori])}}">lihat</a>
	            		<a type="button" class="btn btn-warning btn-sm" href="{{route('kategori.edit',['kategori'=>$kategori])}}">ubah</a>
	            		<form role="form" action="{{route('kategori.destroy',['kategori'=>$kategori])}}" method="POST">
	            			@method('DELETE')
      						@csrf
	            			<button type="submit" class="btn btn-danger btn-sm">Hapus</button>
	            		</form>
	            	</td>            
	          </tr>
			     @endforeach
			
          </tbody>
          <!--
          <tfoot>
	          <tr>
	            <th>Rendering engine</th>
	            <th>Browser</th>
	            <th>Platform(s)</th>            
	          </tr>
	      </tfoot>
      	-->
        </table>
      </div>
      <!-- /.card-body -->
    </div>

@endsection

@push('scripts')
  
  <script src="{{asset('/adminlte/plugins/datatables/jquery.dataTables.js')}}"></script>
  <script src="{{asset('/adminlte/plugins/datatables-bs4/js/dataTables.bootstrap4.js')}}"></script>
  <script>
    $(function () {
      $("#example1").DataTable();
    });

    //alert("ha ha ha");
  </script>

@endpush

inventory/resources/views/kategori/show.blade.php
@extends('adminlte/master')

@section('content')

	<div class="card card-primary ml-3 mt-3 mr-3">
      <div class="card-header">
        <h3 class="card-title">Kategori</h3>
      </div>
      <!-- /.card-header -->
      <!-- form start -->
        
        <div class="card ml-3 mr-3 mt-3 mb-3">
          <div class="card-header">
            <h3 class="card-title">{{$kategori->nama}}</h3>
          </div>
          <div class="card-body" >
            <h5 class="card-title">Berikut dibawah Ini adalah daftar barang di kategori ini!</h5>
            <a class="btn btn-primary" href="{{route('kategori.edit',['kategori'=>$kategori])}}">Ubah Kategori</a>
          </div>
        </div>

        <div class="card">
      <div class="card-header">
        <h3 class="card-title">Daftar Barang dengan kategori : {{$kategori->nama}} </h3>
      </div>
      <!-- /.card-header -->      

      <div class="card-body">

        <table id="example1" class="table table-bordered table-striped">
          <thead>
          <tr>
            <th>No.</th>
            <th>Nama</th>
            <th>Deskripsi</th>            
          </tr>
          </thead>
          <tbody>           
            @foreach ($kategori->get_barang as $key => $barang)          
            <tr>
                <td>{{$key+1}}</td> 
                <td>{{$barang->nama}}</td>
                <td>{!!$barang->deskripsi!!}</td>                
            </tr>
            @endforeach      
          </tbody>
          
        </table>
      </div>
      <!-- /.card-body -->
      </div>

      
    </div>

@endsection